/*	get_cpu_info.c

	Copyright (C) 2000, 2001 Robert D. Russell -- rdr@unh.edu

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "get_cpu_info.h"

#define BUF_SIZE	4096
#define TAG			"cpu MHz"
#define PROC_FILE	"/proc/cpuinfo"

int get_cpu_info( int maxn, double mhz[] )
	{
	FILE	*fptr;
	char	*ptr, buffer[BUF_SIZE];
	double	cpu_mhz;
	int		n;

	n = 0;
	if( (fptr=fopen(PROC_FILE, "r")) == NULL )
		{
		fprintf(stderr, "unable to open %s\n", PROC_FILE);
		exit(EXIT_FAILURE);
		}

	for( ; ; )
		{/* once around loop for each line in the file */
		if( fgets(buffer, BUF_SIZE, fptr) == NULL )
			{
			if( feof(fptr) )
				{/* end of the file, did we find any cpus? */
				fclose(fptr);
				if( n <= 0 )
					/* no, end of file was premature */
					fprintf(stderr, "end of file on %s\n", PROC_FILE);
				else
					/* yes, normal return with that number */
					return n;
				}
			else
				fprintf(stderr, "unable to read %s\n", PROC_FILE);
			exit(EXIT_FAILURE);
			}
		/***** fputs(buffer, stdout); *****/
		if( strncmp(buffer, TAG, strlen(TAG)) == 0 )
			{/* found the line starting with the tag */
			/***** fprintf(stderr, "found line starting with %s\n", TAG); *****/
			if( (ptr = strchr(buffer, ':')) == NULL )
				{
				fprintf(stderr, "cannot find ':' in %s\n", buffer);
				exit(EXIT_FAILURE);
				}
			if( sscanf(ptr+1, "%lf", &cpu_mhz) != 1 )
				{
				fprintf(stderr, "cannot find number after ':' in %s\n", buffer);
				exit(EXIT_FAILURE);
				}
			/***** fprintf(stderr, "found cpu mhz %.2f\n", cpu_mhz); *****/
			if( n >= maxn )
				fprintf(stderr,"too many cpus found, max of %d allowed\n",maxn);
			else
				{
				mhz[n] = cpu_mhz;
				n++;
				}
			}
		}
	}
